import React, { createContext, useContext, useMemo } from 'react';
import { BrowserRouter } from 'react-router-dom';
import { __RouterContext } from 'react-router';
/* eslint-enable */
import { buildRoutingContext } from './utils';
export const routerContext = createContext(buildRoutingContext([]));
export const useNamedRouting = () => useContext(routerContext);
const NamedRouter = ({ routerComponent: RouterComponent = BrowserRouter, routerProps, routes, history, children, }) => {
    const { history: routerHistory } = useContext(__RouterContext);
    const routingContext = useMemo(() => buildRoutingContext(routes, history || routerHistory), [routes]);
    return (React.createElement(RouterComponent, Object.assign({}, routerProps),
        React.createElement(routerContext.Provider, { value: routingContext }, children)));
};
export default NamedRouter;
