import React from 'react';
import { BrowserRouterProps } from 'react-router-dom';
import { RouteConfig } from 'react-router-config';
import { History } from 'history';
import { BaseRoutingContext, RoutingContext } from './utils';
export interface NamedRouteConfig extends RouteConfig {
    name?: string;
    title?: string;
    routes?: NamedRouteConfig[];
}
export interface NamedRouterProps<TRouterProps = BrowserRouterProps> {
    routes: NamedRouteConfig[];
    routerComponent?: React.ComponentType<TRouterProps>;
    routerProps?: TRouterProps;
    history?: History;
    children?: React.ReactNode;
}
export declare const routerContext: React.Context<BaseRoutingContext | RoutingContext>;
export declare const useNamedRouting: () => BaseRoutingContext | RoutingContext;
declare const NamedRouter: ({ routerComponent: RouterComponent, routerProps, routes, history, children, }: NamedRouterProps<BrowserRouterProps>) => JSX.Element;
export default NamedRouter;
